package com.interdataworking;

import org.w3c.rdf.model.*;

public interface ModelGateway {

  /**
   * Initialize the gateway to perform translation for the given layer.
   * <tt>srcMetadata</tt> describes the source implementation of the layer,
   * <tt>destMetadata</tt> describes the destination implementation of the layer
   */
  public void init(Model srcMetadata, Model destMetadata) throws ModelException;

  /**
   * Reset the gateway for the next round of translation
   */
  //  public void reset() throws ModelException {
  //  }

  /** 
   * Used by all "model" gateways
   */
  public Model translate(Model src) throws ModelException;
}
