package com.interdataworking.gateway;

import java.util.*;
import org.w3c.rdf.model.*;
import org.w3c.rdf.util.*;
import com.interdataworking.*;
import com.interdataworking.util.*;
import org.w3c.rdf.vocabulary.rdf_syntax_19990222.RDF;
import org.w3c.rdf.vocabulary.rdf_schema_19990303.RDFS;
import edu.stanford.db.rdf.vocabulary.daml_o_20001011.DAML_O;
import edu.stanford.db.rdf.vocabulary.order_20000527.RDFX;

/**
 * RULE 1:
 *
 * Translate all equivalent pieces of vocabulary
 *
 */

public class RDFS2DAMLO extends SimpleModelGateway {

  static HashMap o2s = new HashMap();

  static Object[][] rdfs2daml_o = {
    { DAML_O.Class, RDFS.Class },
    { DAML_O.comment , RDFS.comment },
    { DAML_O.label , RDFS.label },
    { DAML_O.subPropertyOf , RDFS.subPropertyOf },
    { DAML_O.Literal , RDFS.Literal },
    { DAML_O.Property , RDF.Property },
    // type does not belong to basic typing layer
    { DAML_O.type , RDF.type },
    { DAML_O.value , RDF.value },
    { DAML_O.subClassOf , RDFS.subClassOf },
    { DAML_O.domain , RDFS.domain },
    { DAML_O.range , RDFS.range },
    { DAML_O.seeAlso , RDFS.seeAlso },
    { DAML_O.isDefinedBy , RDFS.isDefinedBy },
    { DAML_O.List , RDF.Seq },
    //    { DAML_O. , RDFS. },
  };

  static {

    for(int i = 0; i < rdfs2daml_o.length; i++)
      o2s.put(rdfs2daml_o[i][1], rdfs2daml_o[i][0]);
  }

  static Resource replaceResource(Resource r) {

    Resource rep = (Resource)o2s.get(r);
    return rep != null ? rep : r;
  }

  public void init(Model srcMD, Model destMD) {
  }

  protected void processStatement(Statement st) throws ModelException {
    
    applyRule1(st);
  }
  
  boolean applyRule1(Statement st) throws ModelException {

    Resource s = st.subject(); // do not replace subject!
    Resource p = replaceResource(st.predicate());
    RDFNode o = st.object();

    if(o instanceof Resource &&
       !DAML_O.range.equals(p) &&
       !DAML_O.domain.equals(p))
      o = replaceResource((Resource)o);

    dest.remove(st);
    dest.add(stmt(s, p, o));

    return true;
  }

}
