package com.interdataworking.gateway.sqlddl;

import com.interdataworking.*;
import com.interdataworking.mm.*;
import com.interdataworking.mm.alg.*;
import org.w3c.rdf.model.*;
import org.w3c.rdf.util.*;
import java.util.*;
import edu.stanford.db.rdf.query.*;
import edu.stanford.db.rdf.query.memory.*;
//import edu.stanford.db.rdf.query.orderings.*;

public class CanonicalMap implements UntypedGateway {

  Obj2SQLDDL os = new Obj2SQLDDL();

  // returns list of MapPairs
  public List getMap(Model model) throws ModelException {

    List result = new ArrayList();

    NodeFactory f = model.getNodeFactory();

    NodeIterator it = new NodeResultSet(os.Q_TBL, model);
    while(it.next()) {

      String tableName = it.get("N").toString();
      MapPair p = new MapPair((Resource)it.get("T"), f.createResource(tableName), 1.0);
      result.add(p);

      NodeIterator itc = new NodeResultSet(os.Q_COL, model);
      itc.set("T", it.get("T"));

      while(itc.next()) {

	String fieldName = itc.get("N").toString();
	MapPair p2 = new MapPair((Resource)itc.get("C"), f.createResource(tableName + "." + fieldName), 1.0);
	result.add(p2);
      }
    }

    return result;
  }

  public List execute(List input) throws ModelException {

    Model src = (Model)input.get(0);

    List map = getMap(src);

    ArrayList l = new ArrayList();
    l.add(MapPair.asModel(src.create(), map));
    return l;
  }
  

  public int getMinInputLen() { return 1; }

  public int getMaxInputLen() { return 1; }

  public int getMinOutputLen() { return 1; }

  public int getMaxOutputLen() { return 1; }
  
}
