package com.interdataworking.mm.alg;

import com.interdataworking.*;
import com.interdataworking.mm.*;
import org.w3c.rdf.model.*;
import org.w3c.rdf.util.*;
import java.util.*;

public class Copy implements UntypedGateway {

  public List execute(List input) throws ModelException {

    Model src = (Model)input.get(0);
    Model dest = src.create();
    Set selector = MapVocabulary.asSet((Model)input.get(1));

    List repl = new ArrayList();
    NodeFactory f = src.getNodeFactory();

    for(Iterator it = selector.iterator(); it.hasNext();) {

      Resource r = (Resource)it.next();
      MapPair p = new MapPair(r, f.createUniqueResource(), 1.0);
      repl.add(p);
    }

    Map map = MapPair.toJavaMapDropSimilarity(repl);

    RDFUtil.replaceResources(src, dest, map);

    repl = Invert.invert(repl);

    List l = new ArrayList();
    l.add(dest);
    l.add(MapPair.asModel(src, repl));
    return l;
  }

  public int getMinInputLen() { return 2; } // model, selector

  public int getMaxInputLen() { return 2; }

  public int getMinOutputLen() { return 2; } // model, map

  public int getMaxOutputLen() { return 2; }

}
