package com.interdataworking.mm.alg;

import com.interdataworking.*;
import org.w3c.rdf.model.*;
import java.util.*;

public class PrecisionRecall implements UntypedGateway {

  public static String getPrecisionRecall(List actual, List correct) {

    Set intended = new HashSet();
    intended.addAll(correct);
    return getPrecisionRecall(actual, intended);
  }

  public static String getPrecisionRecall(List actual, Set intended) {

    // calculate number of correct matches that have been delivered

    int correctNum = 0;

    double sum = 0;
//     double cardProd = 0;
//     double cardSum = 0;
    
    for(int i=0; i<actual.size(); i++) {

      MapPair p = (MapPair)actual.get(i);
      if(intended.contains(p))
	correctNum++;
      sum += p.sim;

//       MapPair.Card c = p.getCardinality(actual);
//       cardProd += p.sim / (c.left * c.right);
//       cardSum += p.sim * 2 / (c.left + c.right);
    }

    int subOp = (actual.size() - correctNum);
    int addOp = (intended.size() - correctNum);

    return
      "Savings: " + (100 - 100 * (subOp+addOp) / intended.size()) + "%, " +
      "Recall: " + (100 * correctNum / intended.size()) + "%, " +
      "Precision: " + (100 * correctNum / actual.size()) + "% " +
      "(computed: " + actual.size() + ", computed correct: " + correctNum +
      ", intended: " + intended.size() + ") " +
      "-" + subOp + " +" + addOp +
      " => " + (subOp + addOp) + " op"; // + MapStatistics.getMapStatistics(actual);
//     \n" +
//       "Total sum: " + sum + ", /prod: " + cardProd + ", /avg: " + cardSum;
  }

  public List execute(List input) throws ModelException {

    Model actual = (Model)input.get(0);
    List l1 = MapPair.toMapPairs(actual);

    Model correct = (Model)input.get(1);
    List l2 = MapPair.toMapPairs(correct);

    System.out.println(getPrecisionRecall(l1, l2));

    return new ArrayList();
  }
  

  public int getMinInputLen() { return 2; }

  public int getMaxInputLen() { return 2; }

  public int getMinOutputLen() { return 0; }

  public int getMaxOutputLen() { return 0; }

}
