package com.interdataworking.mm.alg;

import org.w3c.rdf.model.*;
import org.w3c.rdf.util.*;
import com.interdataworking.mm.*;
import java.util.*;
import org.w3c.rdf.vocabulary.rdf_syntax_19990222.RDF;

public class RDFSMapFilter extends AbstractMapFilter {

  protected NodeFilter getLeftNodeFilter(Model left) throws ModelException {
    return new RDFSNodeFilter(left);
  }
  protected NodeFilter getRightNodeFilter(Model right) throws ModelException {
    return new RDFSNodeFilter(right);
  }

  // additional filtering chance; n1 and n2 are guaranteed to be resources
  protected boolean filterOutPair(RDFNode n1, RDFNode n2) throws ModelException {

    // make sure the types are equal, if any
    Resource t1 = RDFUtil.getObjectResource(left, (Resource)n1, RDF.type);
    Resource t2 = RDFUtil.getObjectResource(right, (Resource)n2, RDF.type);

    if(t1 == null || t2 == null /*|| !t1.equals(t2)*/)
      return true;

    return false;
  }

}
