package com.interdataworking.mm.alg;

import com.interdataworking.*;
import com.interdataworking.mm.*;
import com.interdataworking.mm.alg.*;
import com.interdataworking.mm.interpreter.*;
import org.w3c.rdf.model.*;
import org.w3c.rdf.util.*;
import java.util.*;

//import edu.stanford.db.rdf.util.Aggregator;

/**
 * Given a set of forward and backward arcs, generates a map of
 * <obj, dependent obj>
 **/

public class Submodel implements UntypedGateway {

  public List execute(List input) throws ModelException {

    Model src = (Model)input.get(0);
    Model selectorM = (Model)input.get(1);
    Set selector = MapVocabulary.asSet(selectorM);

    LanguageCallback cb = null;
    ExecutionContext ctx = ((ParameterList)input).getExecutionContext();
    cb = ctx.getLanguageCallback(src);

    Model result = null;
    
    if(cb == null) {
      System.err.println("[Submodel] No callback found, applying Subgraph() instead!");
      result = new Subgraph().getSubgraph(src, selector);

    } else {
      result = cb.select(src, selector);
      if(result == null) {
	System.err.println("[Submodel] Callback does not override, applying Skeleton()!");
// 	p.add(src);
// 	Model allM = (Model)((List)new All().execute(src)).get(0);
	ParameterList p = ctx.createList();
	p.add(src);
	p.add(selectorM);
	return ctx.executeOperator("Skeleton", p);
      }
    }

    ArrayList l = new ArrayList();
    l.add(result);
    return l;
  }
  

  public int getMinInputLen() { return 2; }

  public int getMaxInputLen() { return 2; }

  public int getMinOutputLen() { return 1; }

  public int getMaxOutputLen() { return 1; }
  
}
