package com.interdataworking.mm.alg;

import com.interdataworking.mm.NodeFilter;
import org.w3c.rdf.model.*;
import com.interdataworking.gateway.xml.*;
import java.util.*;
import org.w3c.rdf.vocabulary.rdf_syntax_19990222.RDF;

// ignore everything apart tag names

public class XMLNodeFilter implements NodeFilter {

  Set valid = new HashSet();

  public XMLNodeFilter(Model m) throws ModelException {

    XMLVocabulary.setNodeFactory(m.getNodeFactory());
    XMLVocabulary R = XMLVocabulary.create();

    // collect valid nodes
    Enumeration en = m.elements();
    while(en.hasMoreElements()) {

      Statement st = (Statement)en.nextElement();
      if(R.tagName.equals(st.predicate())) {

	Resource name = (Resource)st.object();
	valid.add(name);
      }
    }
  }

  public boolean filterOutNode(RDFNode n) {

    return !valid.contains(n);
  }
  
}
