package com.interdataworking.mm.gui;

import java.io.*;
import java.util.*;
import org.w3c.rdf.model.*;

public class TLineWriter extends Writer {

  int row = 1, column = 0;

  Writer w;
  Map lines = new HashMap();
  int[] tabs = new int[100]; // pos -> offset

  public TLineWriter(Writer w) {

    this.w = w;
  }

  public Map getLines() {

    return lines;
  }

  public int getRow() {

    return row;
  }

  public int getColumn() {

    return column;
  }

  public void setTab(int num) {

    tabs[num] = column;
  }

  public void setTab(int num, int offset) {

    tabs[num] = column + offset;
  }

  public void writeTab(int num) throws IOException {

    writeTab(num, 0);
  }

  public void writeTab(int num, int offset) throws IOException {

    int len = tabs[num] - column + offset;
    if(len > 0) {
      char[] buf = new char[len];
      Arrays.fill(buf, ' ');
      write(buf);
    }
  }

  public void print(RDFNode n) throws IOException {

    write(String.valueOf(n), n);
  }

  public void write(String str, RDFNode n) throws IOException {

    int start = column;

    if(str == null) {
      write("null");
      return;
    }

    write(str);
    if(n != null) {
      TLine l = new TLine(row, start, column);
      lines.put(n, l);
      //    System.err.println("RDFNode: " + n + " (" + n.getClass() + ") -> " + l);
    }
  }

  public void write(char[] buf, int off, int len) throws IOException {

    w.write(buf, off, len);

    while(len-- > 0) {

      char c = buf[off++];
      if(c == '\n') {
	row++;
	column = 0;
      } else
	column++;
    }
  }

  public void flush() throws IOException {

    w.flush();
  }

  public void close() throws IOException {

    w.close();
  }

}
