package com.interdataworking.util;

import java.util.*;
import com.interdataworking.*;
import org.w3c.rdf.model.*;
import org.w3c.rdf.util.*;


public class StatementTemplate {

  Resource s, p;
  RDFNode o;

  public StatementTemplate(Resource s, Resource p, RDFNode o) {

    this.s = s;
    this.p = p;
    this.o = o;
  }

  public boolean matches(Statement st) throws ModelException {

    if((s != null && !s.equals(st.subject())) ||
       (p != null && !p.equals(st.predicate())) ||
       (o != null && !o.equals(st.object())))
      return false;
    else
      return true;
  }

  public Model findIn(Model m) throws ModelException {

    return m.find(s, p, o);
//     Model res = m.find(s, p, o);
//     System.err.println("" + this + " matched " + res);
//     return res;
  }

  public String toString() {

    return "TEMPLATE[" + s + "," + p + "," + o + "]";
  }
}
