package edu.stanford.db.rdf.query;

import org.w3c.rdf.model.*;
import java.util.*;

/**
 * A general-purpose interface for evaluating
 * n-ary condition predicates (e.g. less-than) on RDF nodes.
 *
 * @see edu.stanford.db.rdf.query.memory.ConditionIterator
 *
 */
public interface ConditionEvaluator {

  /**
   * Returns <tt>true</tt> if condition holds.
   * Be prepared to deal with <tt>null</tt> values of <tt>nodes</tt>!
   */
  boolean holds(RDFNode[] nodes);

  /**
   * Returns the arity of the condition, i.e.,
   * how many parameters it takes.
   */
  int getArity();
}
