package edu.stanford.db.rdf.query.conditions.numeric;

import edu.stanford.db.rdf.query.*;
import org.w3c.rdf.model.*;

/**
 * Equality with a constant
 */
public class LessEqualC extends LessC {

  public LessEqualC(RDFNode constant) {

    super(constant);
  }

  public boolean holds(RDFNode[] n) {

    try {
      return n[0] != null && Double.parseDouble(n[0].getLabel()) <= value;
    } catch (NumberFormatException nfe) {
    } catch (ModelException me) {
    }
    return false;
  }
}
